## tevent 0.9.9~git20100522

=== wscript ===
#!/usr/bin/env python

APPNAME = 'tevent'
VERSION = '0.9.9'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist

samba_dist.DIST_DIRS('lib/tevent:. lib/replace:lib/replace lib/talloc:lib/talloc buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('tevent', noextenion='tevent')
    opt.RECURSE('lib/replace')
    opt.RECURSE('lib/talloc')

def configure(conf):
    conf.RECURSE('lib/replace')
    conf.RECURSE('lib/talloc')

    conf.env.standalone_tevent = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_tevent:
        if conf.CHECK_BUNDLED_SYSTEM('tevent', minversion=VERSION,
                                     onlyif='talloc', implied_deps='replace talloc'):
            conf.define('USING_SYSTEM_TEVENT', 1)

    if conf.CHECK_FUNCS('epoll_create', headers='sys/epoll.h'):
        conf.DEFINE('HAVE_EPOLL', 1)

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/talloc')

    SRC = '''tevent.c tevent_debug.c tevent_fd.c tevent_immediate.c
             tevent_queue.c tevent_req.c tevent_select.c
             tevent_signal.c tevent_standard.c tevent_timed.c tevent_util.c tevent_wakeup.c'''

    if bld.CONFIG_SET('HAVE_EPOLL'):
        SRC += ' tevent_epoll.c'

    if not bld.CONFIG_SET('USING_SYSTEM_TEVENT'):
        bld.SAMBA_LIBRARY('tevent',
                          SRC,
                          deps='replace talloc',
                          enabled= not bld.CONFIG_SET('USING_SYSTEM_TEVENT'),
                          abi_file='ABI/tevent-%s.sigs' % VERSION,
                          abi_match='tevent_* _tevent_*',
                          vnum=VERSION)

    if bld.env.standalone_tevent:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.PKG_CONFIG_FILES('tevent.pc', vnum=VERSION)
        bld.INSTALL_FILES('${INCLUDEDIR}', 'tevent.h')

def test(ctx):
    '''test tevent'''
    print("The tevent testsuite is part of smbtorture in samba4")


def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== buildtools/wafsamba/wscript ===
#!/usr/bin/env python

# this is a base set of waf rules that everything else pulls in first

import sys, wafsamba, Configure
import Options, os, preproc
from samba_utils import *
from optparse import SUPPRESS_HELP

# this forces configure to be re-run if any of the configure
# sections of the build scripts change. We have to check
# for this in sys.argv as options have not yet been parsed when
# we need to set this. This is off by default until some issues
# are resolved related to WAFCACHE. It will need a lot of testing
# before it is enabled by default.
if '--enable-auto-reconfigure' in sys.argv:
    Configure.autoconfig = True

def set_options(opt):
    opt.tool_options('compiler_cc')

    opt.tool_options('gnu_dirs')

    gr = opt.option_group('library handling options')

    gr.add_option('--bundled-libraries',
                   help=("comma separated list of bundled libraries. May include !LIBNAME to disable bundling a library. Can be 'NONE' or 'ALL' [auto]"),
                   action="store", dest='BUNDLED_LIBS', default='')

    extension_default = Options.options['BUNDLED_EXTENSION_DEFAULT']
    gr.add_option('--bundled-library-extension',
                   help=("name extension for bundled libraries [%s]" % extension_default),
                   action="store", dest='BUNDLED_EXTENSION', default=extension_default)

    extension_exception = Options.options['BUNDLED_EXTENSION_EXCEPTION']
    gr.add_option('--bundled-extension-exception',
                   help=("comman separated list of libraries to not apply extension to [%s]" % extension_exception),
                   action="store", dest='BUNDLED_EXTENSION_EXCEPTION', default=extension_exception)

    builtin_defauilt = Options.options['BUILTIN_LIBRARIES_DEFAULT']
    gr.add_option('--builtin-libraries',
                   help=("command separated list of libraries to build directly into binaries [%s]" % builtin_defauilt),
                   action="store", dest='BUILTIN_LIBRARIES', default=builtin_defauilt)

    gr.add_option('--minimum-library-version',
                   help=("list of minimum system library versions (LIBNAME1:version,LIBNAME2:version)"),
                   action="store", dest='MINIMUM_LIBRARY_VERSION', default='')

    gr.add_option('--disable-shared',
                   help=("Disable all use of shared libraries"),
                   action="store_true", dest='disable_shared', default=False)
    gr.add_option('--disable-rpath',
                   help=("Disable use of rpath for build binaries"),
                   action="store_true", dest='disable_rpath_build', default=False)
    gr.add_option('--disable-rpath-install',
                   help=("Disable use of rpath for installed binaries"),
                   action="store_true", dest='disable_rpath_install', default=False)
    gr.add_option('--nonshared-binary',
                   help=("Disable use of shared libs for the listed binaries"),
                   action="store", dest='NONSHARED_BINARIES', default='')

    opt.add_option('--with-modulesdir',
                   help=("modules directory [PREFIX/modules]"),
                   action="store", dest='MODULESDIR', default='${PREFIX}/modules')

    gr = opt.option_group('developer options')

    gr.add_option('-C',
                   help='enable configure cacheing',
                   action='store_true', dest='enable_configure_cache')
    gr.add_option('--enable-auto-reconfigure',
                   help='enable automatic reconfigure on build',
                   action='store_true', dest='enable_auto_reconfigure')
    gr.add_option('--enable-developer',
                   help=("Turn on developer warnings and debugging"),
                   action="store_true", dest='developer', default=False)
    gr.add_option('--picky-developer',
                   help=("Treat all warnings as errors (enable -Werror)"),
                   action="store_true", dest='picky_developer', default=False)
    gr.add_option('--fatal-errors',
                   help=("Stop compilation on first error (enable -Wfatal-errors)"),
                   action="store_true", dest='fatal_errors', default=False)
    gr.add_option('--enable-gccdeps',
                   help=("Enable use of gcc -MD dependency module"),
                   action="store_true", dest='enable_gccdeps', default=False)
    gr.add_option('--timestamp-dependencies',
                   help=("use file timestamps instead of content for build dependencies (BROKEN)"),
                   action="store_true", dest='timestamp_dependencies', default=False)
    gr.add_option('--pedantic',
		   help=("Enable even more compiler warnings"),
		   action='store_true', dest='pedantic', default=False)

    gr.add_option('--abi-check',
		   help=("Check ABI signatures for libraries"),
		   action='store_true', dest='ABI_CHECK', default=False)
    gr.add_option('--abi-check-disable',
		   help=("Disable ABI checking (used with --enable-developer)"),
		   action='store_true', dest='ABI_CHECK_DISABLE', default=False)
    gr.add_option('--abi-update',
		   help=("Update ABI signature files for libraries"),
		   action='store_true', dest='ABI_UPDATE', default=False)

    gr = opt.add_option_group('cross compilation options')

    gr.add_option('--cross-compile',
		   help=("configure for cross-compilation"),
		   action='store_true', dest='CROSS_COMPILE', default=False)
    gr.add_option('--cross-execute',
		   help=("command prefix to use for cross-execution in configure"),
		   action='store', dest='CROSS_EXECUTE', default='')
    gr.add_option('--cross-answers',
		   help=("answers to cross-compilation configuration (auto modified)"),
		   action='store', dest='CROSS_ANSWERS', default='')
    gr.add_option('--hostcc',
		   help=("set host compiler when cross compiling"),
		   action='store', dest='HOSTCC', default=False)

    # we use SUPPRESS_HELP for these, as they are ignored, and are there only
    # to allow existing RPM spec files to work
    opt.add_option('--build',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_BUILD', default='')
    opt.add_option('--host',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_HOST', default='')
    opt.add_option('--program-prefix',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_PROGRAM_PREFIX', default='')
    opt.add_option('--disable-dependency-tracking',
		   help=SUPPRESS_HELP,
		   action='store_true', dest='AUTOCONF_DISABLE_DEPENDENCY_TRACKING', default=False)


@wafsamba.runonce
def configure(conf):
    conf.env.hlist = []
    conf.env.srcdir = conf.srcdir

    if Options.options.timestamp_dependencies:
        conf.ENABLE_TIMESTAMP_DEPENDENCIES()

    conf.SETUP_CONFIGURE_CACHE(Options.options.enable_configure_cache)

    # load our local waf extensions
    conf.check_tool('gnu_dirs')
    conf.check_tool('wafsamba')

    conf.CHECK_CC_ENV()

    conf.check_tool('compiler_cc')

    # we need git for 'waf dist'
    conf.find_program('git', var='GIT')

    if Options.options.enable_gccdeps:
        # don't enable gccdeps by default as it needs a very recent version gcc
        conf.check_tool('gccdeps', tooldir=conf.srcdir + "/buildtools/wafsamba")

    # make the install paths available in environment
    conf.env.LIBDIR = Options.options.LIBDIR or '${PREFIX}/lib'
    conf.env.BINDIR = Options.options.BINDIR or '${PREFIX}/bin'
    conf.env.SBINDIR = Options.options.SBINDIR or '${PREFIX}/sbin'
    conf.env.MODULESDIR = Options.options.MODULESDIR
    conf.env.BUNDLED_LIBS = Options.options.BUNDLED_LIBS.split(',')
    conf.env.BUILTIN_LIBRARIES = Options.options.BUILTIN_LIBRARIES.split(',')
    conf.env.DISABLE_SHARED = Options.options.disable_shared
    conf.env.NONSHARED_BINARIES = Options.options.NONSHARED_BINARIES.split(',')

    conf.env.BUNDLED_EXTENSION = Options.options.BUNDLED_EXTENSION
    conf.env.BUNDLED_EXTENSION_EXCEPTION = Options.options.BUNDLED_EXTENSION_EXCEPTION.split(',')

    conf.env.CROSS_COMPILE = Options.options.CROSS_COMPILE
    conf.env.CROSS_EXECUTE = Options.options.CROSS_EXECUTE
    conf.env.CROSS_ANSWERS = Options.options.CROSS_ANSWERS
    conf.env.HOSTCC        = Options.options.HOSTCC

    conf.env.AUTOCONF_BUILD = Options.options.AUTOCONF_BUILD
    conf.env.AUTOCONF_HOST  = Options.options.AUTOCONF_HOST
    conf.env.AUTOCONF_PROGRAM_PREFIX = Options.options.AUTOCONF_PROGRAM_PREFIX

    if (conf.env.AUTOCONF_HOST and
        conf.env.AUTOCONF_BUILD and
        conf.env.AUTOCONF_BUILD != conf.env.AUTOCONF_HOST):
        Logs.error('ERROR: Mismatch between --build and --host. Please use --cross-compile instead')
        sys.exit(1)
    if conf.env.AUTOCONF_PROGRAM_PREFIX:
        Logs.error('ERROR: --program-prefix not supported')
        sys.exit(1)

    # enable ABI checking for developers
    conf.env.ABI_CHECK = Options.options.ABI_CHECK or Options.options.developer
    if Options.options.ABI_CHECK_DISABLE:
        conf.env.ABI_CHECK = False
    try:
        conf.find_program('gdb', mandatory=True)
    except:
        conf.env.ABI_CHECK = False

    conf.CHECK_COMMAND(['uname', '-a'],
                       msg='Checking build system',
                       define='BUILD_SYSTEM',
                       on_target=False)
    conf.CHECK_UNAME()

    # see if we can compile and run a simple C program
    conf.CHECK_CODE('printf("hello world")',
                    define='HAVE_SIMPLE_C_PROG',
                    mandatory=True,
                    execute=True,
                    headers='stdio.h',
                    msg='Checking simple C program')

    # see if we can build shared libs
    if not conf.CHECK_LIBRARY_SUPPORT():
        conf.env.DISABLE_SHARED = True

    # check for rpath
    if not conf.env.DISABLE_SHARED and conf.CHECK_LIBRARY_SUPPORT(rpath=True):
        conf.env.RPATH_ON_BUILD   = not Options.options.disable_rpath_build
        conf.env.RPATH_ON_INSTALL = (conf.env.RPATH_ON_BUILD and
                                     not Options.options.disable_rpath_install)
    else:
        conf.env.RPATH_ON_INSTALL = False
        conf.env.RPATH_ON_BUILD   = False

    # we should use the PIC options in waf instead
    conf.ADD_CFLAGS('-fPIC', testflags=True)

    conf.CHECK_INLINE()

    # check for pkgconfig
    conf.check_cfg(atleast_pkgconfig_version='0.0.0')

    conf.DEFINE('_GNU_SOURCE', 1, add_to_cflags=True)
    conf.DEFINE('_XOPEN_SOURCE_EXTENDED', 1, add_to_cflags=True)

    # get the base headers we'll use for the rest of the tests
    conf.CHECK_HEADERS('stdio.h sys/types.h sys/stat.h stdlib.h stddef.h memory.h string.h',
                       add_headers=True)
    conf.CHECK_HEADERS('strings.h inttypes.h stdint.h unistd.h minix/config.h', add_headers=True)
    conf.CHECK_HEADERS('ctype.h standards.h stdbool.h stdint.h stdarg.h vararg.h', add_headers=True)
    conf.CHECK_HEADERS('limits.h assert.h')

    # see if we need special largefile flags
    conf.CHECK_LARGEFILE()

    if 'HAVE_STDDEF_H' in conf.env and 'HAVE_STDLIB_H' in conf.env:
        conf.DEFINE('STDC_HEADERS', 1)

    conf.CHECK_HEADERS('sys/time.h time.h', together=True)

    if 'HAVE_SYS_TIME_H' in conf.env and 'HAVE_TIME_H' in conf.env:
        conf.DEFINE('TIME_WITH_SYS_TIME', 1)

    conf.define('SHLIBEXT', "so", quote=True)

    conf.CHECK_CODE('long one = 1; return ((char *)(&one))[0]',
                    execute=True,
                    define='WORDS_BIGENDIAN')

    # check if signal() takes a void function
    if conf.CHECK_CODE('return *(signal (0, 0)) (0) == 1',
                       define='RETSIGTYPE_INT',
                       execute=False,
                       headers='signal.h',
                       msg='Checking if signal handlers return int'):
        conf.DEFINE('RETSIGTYPE', 'int')
    else:
        conf.DEFINE('RETSIGTYPE', 'void')

    conf.CHECK_VARIABLE('__FUNCTION__', define='HAVE_FUNCTION_MACRO')

    conf.CHECK_CODE('va_list ap1,ap2; va_copy(ap1,ap2)',
                    define="HAVE_VA_COPY",

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

blddir = 'bin'

import sys, os, Utils

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist
import Options, os, preproc

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.BUNDLED_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@wafsamba.runonce
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    # on Tru64 certain features are only available with _OSF_SOURCE
    if conf.env['SYSTEM_UNAME_SYSNAME'] == 'OSF1':
        conf.DEFINE('_OSF_SOURCE', 1, add_to_cflags=True)

    conf.CHECK_HEADERS('crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('libaio.h locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h sys/fs/vx/quota.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h')
    conf.CHECK_HEADERS('sys/wait.h sys/stat.h malloc.h grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('libintl.h errno.h')
    conf.CHECK_HEADERS('gcrypt.h getopt.h iconv.h')
    conf.CHECK_HEADERS('sys/inotify.h memory.h nss.h sasl/sasl.h')
    conf.CHECK_HEADERS('security/pam_appl.h sys/inotify.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('aio.h sys/unistd.h rpc/rpc.h rpc/nettype.h alloca.h float.h')

    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h sys/prctl.h sys/sysctl.h')
    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h rpcsvc/yp_prot.h')
    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h valgrind/memcheck.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t')
    conf.CHECK_TYPES('comparison_fn_t bool')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('bool', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')

    conf.CHECK_FUNCS_IN('''inet_ntoa inet_aton inet_ntop inet_pton connect gethostbyname
                           getaddrinfo getnameinfo freeaddrinfo gai_strerror socketpair''',
                        'socket nsl', checklibc=True,
                        headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
			  const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,
                                           (const void *)&val, sizeof(val));
                       }
                       ''',
                    define='HAVE_IPV6',
                    lib='nsl socket',
                    headers='sys/socket.h netdb.h netinet/in.h')

    # these may be builtins, so we need the link=False strategy
    conf.CHECK_FUNCS('strdup memmem printf memset memcpy memmove strcpy strncpy bzero', link=False)

    conf.CHECK_FUNCS('shl_load shl_unload shl_findsym')
    conf.CHECK_FUNCS('pipe strftime srandom random srand rand usleep setbuffer')
    conf.CHECK_FUNCS('lstat getpgrp utime utimes seteuid setresuid setegid')
    conf.CHECK_FUNCS('setresgid chroot strerror vsyslog setlinebuf mktime')
    conf.CHECK_FUNCS('ftruncate chsize rename waitpid wait4 strlcpy strlcat')
    conf.CHECK_FUNCS('initgroups pread pwrite strndup strcasestr')
    conf.CHECK_FUNCS('strtok_r mkdtemp dup2 dprintf vdprintf isatty chown lchown')
    conf.CHECK_FUNCS('link readlink symlink realpath snprintf vsnprintf')
    conf.CHECK_FUNCS('asprintf vasprintf setenv unsetenv strnlen strtoull __strtoull')
    conf.CHECK_FUNCS('strtouq strtoll __strtoll strtoq')
    conf.CHECK_FUNCS('if_nametoindex strerror_r')
    conf.CHECK_FUNCS('getdirentries getdents syslog')
    conf.CHECK_FUNCS('gai_strerror get_current_dir_name')
    conf.CHECK_FUNCS('timegm getifaddrs freeifaddrs mmap setgroups setsid')
    conf.CHECK_FUNCS('getgrent_r getgrgid_r getgrnam_r getgrouplist getpagesize')
    conf.CHECK_FUNCS('getpwent_r getpwnam_r getpwuid_r epoll_create')

    conf.CHECK_FUNCS_IN('dlopen dlsym dlerror dlclose', 'dl',
                        checklibc=True, headers='dlfcn.h dl.h')

    conf.CHECK_C_PROTOTYPE('dlopen', 'void *dlopen(const char* filename, unsigned int flags)',
                           define='DLOPEN_TAKES_UNSIGNED_FLAGS', headers='dlfcn.h dl.h')

    conf.CHECK_FUNCS_IN('fdatasync', 'rt', checklibc=True)

    # these headers need to be tested as a group on freebsd
    conf.CHECK_HEADERS(headers='sys/socket.h net/if.h', together=True)
    conf.CHECK_HEADERS(headers='netinet/in.h arpa/nameser.h resolv.h', together=True)
    conf.CHECK_FUNCS_IN('res_search', 'resolv', checklibc=True,
                        headers='netinet/in.h arpa/nameser.h resolv.h')

    conf.CHECK_FUNCS_IN('gettext', 'intl', checklibc=True, headers='libintl.h')
    conf.CHECK_FUNCS_IN('pthread_create', 'pthread', checklibc=True, headers='pthread.h')

    conf.CHECK_FUNCS_IN('crypt', 'crypt', checklibc=True)

    conf.CHECK_VARIABLE('rl_event_hook', define='HAVE_DECL_RL_EVENT_HOOK', always=True,
                        headers='readline.h readline/readline.h readline/history.h')

    conf.CHECK_DECLS('snprintf vsnprintf asprintf vasprintf')

    conf.CHECK_DECLS('errno', headers='errno.h', reverse=True)
    conf.CHECK_DECLS('environ getgrent_r getpwent_r', reverse=True, headers='pwd.h grp.h')
    conf.CHECK_DECLS('pread pwrite setenv setresgid setresuid', reverse=True)

    conf.CHECK_SIZEOF('char int "long long" long off_t short size_t ssize_t')
    conf.CHECK_SIZEOF('dev_t ino_t time_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')

    if conf.CONFIG_SET('HAVE_EPOLL_CREATE') and conf.CONFIG_SET('HAVE_SYS_EPOLL_H'):
        conf.DEFINE('HAVE_EPOLL', 1)

    if not conf.CHECK_CODE('''#define LIBREPLACE_CONFIGURE_TEST_STRPTIME
		       #include "$libreplacedir/test/strptime.c"''',
                           define='HAVE_STRPTIME',
                           msg='Checking for working strptime'):
        conf.DEFINE('REPLACE_STRPTIME', 1)

    if conf.CONFIG_SET('HAVE_KRB5_H'):
        # Check for KRB5_DEPRECATED handling
        conf.CHECK_CODE('''#define KRB5_DEPRECATED 1
#include <krb5.h>''',
                        'HAVE_KRB5_DEPRECATED_WITH_IDENTIFIER', addmain=False,
                        link=False,
                        msg="Checking for KRB5_DEPRECATED define taking an identifier")

    conf.CHECK_CODE('gettimeofday(NULL, NULL)', 'HAVE_GETTIMEOFDAY_TZ', execute=False)

    conf.CHECK_CODE('#include "test/snprintf.c"',
                    define="HAVE_C99_VSNPRINTF",
                    execute=1,
                    addmain=False,
                    msg="Checking for C99 vsnprintf")

    conf.SAMBA_BUILD_ENV()

    conf.CHECK_CODE('''
		    typedef struct {unsigned x;} FOOBAR;
                    #define X_FOOBAR(x) ((FOOBAR) { x })
                    #define FOO_ONE X_FOOBAR(1)
                    FOOBAR f = FOO_ONE;
                    static const struct {
                        FOOBAR y;
                    } f2[] = {
                        {FOO_ONE}
                    };
                    static const FOOBAR f3[] = {FOO_ONE};
                    ''',
                    define='HAVE_IMMEDIATE_STRUCTURES')

    conf.CHECK_CODE('mkdir("foo",0777)', define='HAVE_MKDIR_MODE', headers='sys/stat.h')

    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_mtim.tv_nsec', define='HAVE_STAT_TV_NSEC',
                                headers='sys/stat.h')
    # we need the st_rdev test under two names
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_rdev',
                                define='HAVE_STRUCT_STAT_ST_RDEV',
                                headers='sys/stat.h')
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_rdev', define='HAVE_ST_RDEV',
                                headers='sys/stat.h')

=== lib/talloc/wscript ===
#!/usr/bin/env python

APPNAME = 'talloc'
VERSION = '2.0.3'


blddir = 'bin'

import os, sys

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import sys
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
import wafsamba, samba_dist, Options

# setup what directories to put in a tarball
samba_dist.DIST_DIRS('lib/talloc:. lib/replace:lib/replace buildtools:buildtools')


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('talloc', noextenion='talloc')
    opt.RECURSE('lib/replace')
    opt.add_option('--enable-talloc-compat1',
                   help=("Build talloc 1.x.x compat library [False]"),
                   action="store_true", dest='TALLOC_COMPAT1', default=False)

def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_talloc = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_talloc:
        if conf.CHECK_BUNDLED_SYSTEM('talloc', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TALLOC', 1)

    conf.env.TALLOC_COMPAT1 = Options.options.TALLOC_COMPAT1

    if conf.env.standalone_talloc:
        conf.find_program('xsltproc', var='XSLTPROC')

    conf.SAMBA_CONFIG_H()



def build(bld):
    bld.RECURSE('lib/replace')

    if not bld.CONFIG_SET('USING_SYSTEM_TALLOC'):

        bld.SAMBA_LIBRARY('talloc',
                          'talloc.c',
                          deps='replace',
                          abi_file='ABI/talloc-%s.sigs' % VERSION,
                          abi_match='talloc* _talloc*',
                          hide_symbols=True,
                          vnum=VERSION)

        # should we also install the symlink to libtalloc1.so here?
        bld.SAMBA_LIBRARY('talloc-compat1',
                          'compat/talloc_compat1.c',
                          deps='talloc',
                          enabled = bld.env.TALLOC_COMPAT1,
                          vnum=VERSION)

    if not getattr(bld.env, '_SAMBA_BUILD_', 0) == 4:
        # s4 already has the talloc testsuite builtin to smbtorture
        bld.SAMBA_BINARY('talloc_testsuite',
                         'testsuite_main.c testsuite.c',
                         deps='talloc',
                         install=False)

    if bld.env.standalone_talloc:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.env.TALLOC_VERSION = VERSION
        bld.PKG_CONFIG_FILES('talloc.pc', vnum=VERSION)
        bld.INSTALL_FILES('${INCLUDEDIR}', 'talloc.h')

        if bld.env.XSLTPROC:
            bld.env.TALLOC_MAN_XSL = 'http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl'
            bld.env.TALLOC_WEB_XSL = 'http://docbook.sourceforge.net/release/xsl/current/html/docbook.xsl'
            bld.SAMBA_GENERATOR('talloc.3',
                                source='talloc.3.xml',
                                target='talloc.3',
                                rule='${XSLTPROC} -o ${TGT} ${TALLOC_MAN_XSL} ${SRC}'
                                )
            bld.SAMBA_GENERATOR('talloc.3.html',
                                source='talloc.3.xml',
                                target='talloc.3.html',
                                rule='${XSLTPROC} -o ${TGT} ${TALLOC_WEB_XSL} ${SRC}'
                                )
            bld.INSTALL_FILES('${MANDIR}/man3', 'talloc.3')


def test(ctx):
    '''run talloc testsuite'''
    import Utils
    cmd = os.path.join(Utils.g_module.blddir, 'talloc_testsuite')
    os.system(cmd)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== debian/changelog ===
tevent (0.9.9~git20100522-3ubuntu1) maverick; urgency=low

  * Merge in new upstream snapshot. (LP: #636400)
  * Support building against talloc 2.0.1.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 13 Sep 2010 15:28:58 +0200

tevent (0.9.9~git20100522-3) experimental; urgency=low

  * Add missing dependency on pkg-config and python. Closes: #595642

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 27 Aug 2010 02:35:21 +0200

tevent (0.9.9~git20100522-2) experimental; urgency=low

  * Bump standards version to 3.9.1.
   + Inline BSD license in copyright file.
  * Add missing build dependency on Python (required by waf).
  * Depend on talloc >= 2.0.3.
  * Switch to Bazaar.

 -- Jelmer Vernooij <jelmer@debian.org>  Thu, 26 Aug 2010 23:33:51 +0200

tevent (0.9.9~git20100522-1) experimental; urgency=low

  * New upstream snapshot.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 23 May 2010 15:37:56 +0200

tevent (0.9.9~git20100514-1) experimental; urgency=low

  * New upstream snapshot.
  * Bump standards version to 3.8.4.
  * Use source format 3.

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 14 May 2010 18:12:51 +0200

tevent (0.9.8-1) unstable; urgency=low

  * New upstream release.
  * Bump standards version to 3.8.3.

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 11 Sep 2009 22:40:00 +0200

tevent (0.9.6~20090604-1) experimental; urgency=low

  * New upstream snapshot.

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 05 Jun 2009 01:08:49 +0200

tevent (0.9.5~20090516-1) unstable; urgency=low

  * New upstream snapshot.
  * Bump standards version to 3.8.1.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 16 May 2009 04:30:35 +0200

tevent (0.9.3~git20090221-1) unstable; urgency=low

  * New upstream snapshot.
  * Add dependency on libaio-dev.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 02 Feb 2009 23:33:20 +0100

tevent (0.9.2~git20090105-1) unstable; urgency=low

  * Initial release. (Closes: #509225)

 -- Jelmer Vernooij <jelmer@debian.org>  Tue, 06 Jan 2009 20:57:29 +0100

=== debian/control ===
Source: tevent
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jelmer Vernooij <jelmer@debian.org>
Build-Depends: debhelper (>> 5.0.0), libtalloc-dev (>= 2.0.1~), libaio-dev, pkg-config, python
Standards-Version: 3.9.1
Vcs-Bzr: http://bzr.debian.org/pkg-samba/tevent/experimental

Package: libtevent0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: talloc-based event loop library - shared library
 tevent is a simple library that can handle the main event loop for an
 application. It supports three kinds of events: timed events, file
 descriptors becoming readable or writable and signals.
 .
 Talloc is used for memory management, both internally and for private
 data provided by users of the library.
 .
 This package provides the shared library file.

Package: libtevent-dev
Section: libdevel
Architecture: any
Depends: libc6-dev, libtevent0 (= ${binary:Version}), libtalloc-dev, ${misc:Depends}
Description: talloc-based event loop library - development files
 tevent is a simple library that can handle the main event loop for an
 application. It supports three kinds of events: timed events, file
 descriptors becoming readable or writable and signals.
 .
 Talloc is used for memory management, both internally and for private
 data provided by users of the library.
 .
 This package provides the development files.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS = -g -Wall

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

DESTDIR=$(CURDIR)/debian/tmp

configure: configure-stamp
configure-stamp:
	dh_testdir
	./autogen-waf.sh
	CFLAGS="$(CFLAGS)" ./configure --prefix=/usr --bundled-libraries=NONE \
		   --disable-rpath --disable-rpath-install \
		   --minimum-library-version=talloc:2.0.1
	touch configure-stamp

build: configure build-stamp
build-stamp:
	dh_testdir
	$(MAKE) all 
	touch build-stamp

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf build
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) install DESTDIR=$(DESTDIR)
	ar cr libtevent.a bin/default/*.o
	cp libtevent.a $(DESTDIR)/usr/lib/
	# No python for now
	rm -f $(DESTDIR)/usr/lib/python*/site-packages/tevent.so
	dh_install --fail-missing --list-missing --sourcedir=$(DESTDIR) 

binary-indep: 
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs 
	dh_installman
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install configure

## tevent 0.9.9~git20100928

=== debian/changelog ===
tevent (0.9.9~git20100928-2) unstable; urgency=low

  * Depend on python-dev to build new Python module. Closes: #598374

 -- Jelmer Vernooij <jelmer@debian.org>  Tue, 28 Sep 2010 17:21:10 +0200

tevent (0.9.9~git20100928-1) unstable; urgency=low

  * Support building against talloc 2.0.1.
  * New upstream snapshot. Closes: #598362

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 13 Sep 2010 15:28:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: tevent
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jelmer Vernooij <jelmer@debian.org>
-Build-Depends: debhelper (>> 5.0.0), libtalloc-dev (>= 2.0.1~), libaio-dev, pkg-config, python
+Maintainer: Jelmer Vernooij <jelmer@debian.org>
+Build-Depends: debhelper (>> 5.0.0), libtalloc-dev (>= 2.0.1~), libaio-dev, pkg-config, python-dev
 Standards-Version: 3.9.1
-Vcs-Bzr: http://bzr.debian.org/pkg-samba/tevent/experimental
+Vcs-Bzr: http://bzr.debian.org/pkg-samba/tevent/unstable
 
 Package: libtevent0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,6 @@
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-	./autogen-waf.sh
 	CFLAGS="$(CFLAGS)" ./configure --prefix=/usr --bundled-libraries=NONE \
 		   --disable-rpath --disable-rpath-install \
 		   --minimum-library-version=talloc:2.0.1
@@ -25,11 +24,15 @@
 	$(MAKE) all 
 	touch build-stamp
 
+get-orig-source:
+	./debian/build-orig.sh
+
 clean: 
 	dh_testdir
 	dh_testroot
 	rm -f build-stamp configure-stamp
-	[ ! -f Makefile ] || $(MAKE) distclean
+	-./buildtools/bin/waf clean
+	rm -rf buildtools/wafsamba/*.pyc buildtools/bin/.waf-*
 	rm -rf build
 	dh_clean
 
@@ -42,7 +45,7 @@
 	ar cr libtevent.a bin/default/*.o
 	cp libtevent.a $(DESTDIR)/usr/lib/
 	# No python for now
-	rm -f $(DESTDIR)/usr/lib/python*/site-packages/tevent.so
+	rm -f $(DESTDIR)/usr/lib/python*/*-packages/_tevent.so
 	dh_install --fail-missing --list-missing --sourcedir=$(DESTDIR) 
 
 binary-indep:
